package flm.b4a.accelerview;

import android.content.Context;
import android.graphics.Camera;
import android.graphics.Canvas;
import android.graphics.Matrix;
import android.graphics.Paint;
import android.graphics.RectF;
import android.view.View;
import anywheresoftware.b4a.BA;

@BA.Hide
public class AcceleratedView extends View
{
	protected String eventDraw = "";
	protected String eventTouch = "";
	protected String eventUpdate = "";
	protected BA ba = null;

	private final AcceleratedCanvas AC;
	private final Camera camera;
	private final Paint paint;
	private final Matrix matrix;
	private final RectF rectF;

	public AcceleratedView(Context context) {
		super(context);
		AC = new AcceleratedCanvas();
		camera = new Camera();
		paint = new Paint();
		matrix = new Matrix();
		rectF = new RectF();
	}

	private long Now;
	protected long Last = 0;
	protected long Delta = 0;

	@Override
	protected void onDraw(Canvas c)
	{
		if (Last > 0) {
			Now = System.currentTimeMillis();
			Delta = Now - Last;
			Last = Now;
		}
		if (ba != null && !eventDraw.equals("")) {
			if (AC.cvs != c) {
				AC.Initialize(c, this.getWidth(), this.getHeight(), camera, paint, matrix, rectF);
			}
			ba.raiseEvent(ba.getSender(), eventDraw, new Object[] { AC });
		}
	}
}
